#' ---
#' title: |
#'   医薬品開発のための統計解析 第２部５章５節 \
#'   ２因子実験（量的因子×量的因子）\
#'   Green2-5-5.R
#' author: "Masahiko Katase"
#' date: "2021/7/10"
#' ---

#+ message = FALSE
library(readxl)    # read_excel
library(rsm)       # rsm, coded.data

df <- read_excel("Green2-5.xlsx", sheet = "5-2inshi4")
df <- data.frame(df)

#'# 表示5.5.6 JMP の出力（p.200）
center1 <- mean(df$x1)
center2 <- mean(df$x2)
df1 <- coded.data(df, xx1 ~ x1 - center1, xx2 ~ x2 - center2) 

rsm_out1 <- rsm(y ~ FO(xx1, xx2) + TWI(xx1, xx2) + PQ(xx1, xx2), data = df1)
summary(rsm_out1)

#'# 表示5.5.7 JMP の出力（p.201）
opt_xx1 <- canonical(rsm_out1)$xs[1]
opt_xx2 <- canonical(rsm_out1)$xs[2]
opt_xx <- data.frame(xx1 = opt_xx1, xx2 = opt_xx2)
predict(rsm_out1, opt_xx)

par(mfrow = c(1,1))
contour(rsm_out1, ~ xx1 + xx2, image = TRUE)
points(df$x1, df$x2, pch = 19)

persp(rsm_out1, xx1 ~ xx2, col = terrain.colors(50))

